function __dragDrop(){
   this.mousemove=document.onmousemove;
   this.mouseup=document.onmouseup;
   this.mousedown=document.onmousedown;
	this.olddblclick=document.ondblclick;
   this.lastElement = null;
   this.pressed=false;
	this.startX=null;
	this.startY=null;
   this.x=null;
   this.y=null;
	this.layer=null;
   this.init=0;
   var f = function(evt){_dblClick(evt,this);};
   if(document.all){
       document.ondblclick = f;
   }
   else{
       document.documentElement.addEventListener("dblclick",f,true);
   }
   document.onmousedown = function(evt){_mouseDown(evt,this);};
   document.onmouseup = function(evt){_mouseUp(evt,this);};
   document.onmousemove = function(evt){_mouseMove(evt,this);};
}

function _mouseDown(evt,dr){
   var elm = (document.all)?event.srcElement:evt.target;
   var moveElement = _getMover(elm);
   if(moveElement!=null && moveElement.mover[0].isMoveStart(elm)){
       dr.lastElement = moveElement;
	   dr.pressed=true;
		dr.init=0;
		if(document.all) event.returnValue = false;
		else evt.preventDefault();
        return false;
   }
   return true;
}

function _mouseMove(evt,dr){
    if(dr.pressed){
     var b = (document.all)?event.button:evt.button;
		 if(document.all && b==0){
	      if (dr.layer) dr.layer.style.visibility="hidden";
    //hide drag/drop
	      dr.lastElement = null;
	      dr.pressed=false;
	      dr.x=null;
	      dr.y=null;
	      dr.init=0;
	   }else if(dr.init==0){		//init start coords
		  dr.startX=dr.x=_getMouseX(evt);
		  dr.startY=dr.y=_getMouseY(evt);
		  dr.init=1;
	   }
	   else if(dr.init==1){  //if moved enagh for drag - show drag and drop
		   var dX = Math.abs(dr.x - _getMouseX(evt));
			 var dY = Math.abs(dr.y - _getMouseY(evt));
			 if(dX > 2 || dY > 2){
			     //if(!dr.layer || dr.layer==null){
						 dr.layer=dr.lastElement.mover[0].getDragIcon(dr.lastElement);
						 document.body.appendChild(dr.layer);
          // }
           /*dr.layer.style.left=_getMouseX(evt) + 1;
			  dr.layer.style.top=_getMouseY(evt) + 1;
			  dr.layer.style.visibility="visible";	*/
			  dr.init=2;
					
			 }
	   }
	   else{
		    if(dr.layer){
				 dr.lastElement.mover[0].moveDragIcon(dr.layer,evt,_getMouseX(evt)+1,_getMouseY(evt)+1);
		         /*dr.layer.style.left=_getMouseX(evt)+1;
					dr.layer.style.top=_getMouseY(evt)+1; */
				}
	   }
		if(document.all) event.returnValue = false;
		else evt.preventDefault();
	}
    return true;
}

function _mouseUp(evt,dr){
   if(dr.pressed){
	  var elm = (document.all)?event.srcElement:evt.target;
	  var trg = elm;
	  var mover = null;
	  if(dr.lastElement){
		  for(var i=0;i<dr.lastElement.mover.length;i++){
			  if(dr.lastElement.mover[i].isValidMove(dr.lastElement,trg)){
				  mover=dr.lastElement.mover[i];
					break;
				}
			}
	  if(mover && mover != null){
		  mover.doDrop(trg,evt,dr.startX,dr.startY);
	  }
	}
	  if (dr.layer) dr.layer.style.visibility="hidden";
	  dr.lastElement = null;
	  dr.startX=dr.x=null;
	  dr.startY=dr.y=null;
	  dr.pressed=false;
	  dr.init=0;
	  document.body.style.cursor='default';
      if(dr.mouseup) return dr.mouseup(evt);
      return false;
   }
   return true;
}

function _dblClick(evt, dr){
    var elm = (document.all)?event.srcElement:evt.target;
    var moveElement = _getMover(elm);
    if(moveElement && moveElement.mover[0].dest){
        var trg = (isChildOf(elm,moveElement.mover[0].src.getDiv()))?moveElement.mover[0].dest:moveElement.mover[0].src;
        moveElement.mover[0].doDrop(trg.getDiv(),evt,0,0);
        if(dr.mouseup) return dr.olddblclick(evt);
        return false;
    }
    return true;
}

