
function getOffsetLeft (el) {
  var ol = el.offsetLeft;
  while ((el = el.offsetParent) != null)
    ol += el.offsetLeft;
  return ol;
}

function getOffsetTop (el) {
  var ot = el.offsetTop;
  while((el = el.offsetParent) != null)
   ot += el.offsetTop;
  return ot;
}


function isChildOf(child,parent){
   while(child.parentNode && child != parent && child != parent.parentNode){
       child = child.parentNode;
   }
   return child==parent;
}

function getParentTag(dest, tagName){
   while(dest && dest.tagName != tagName){
      dest=dest.parentNode;
   }
   return dest;
}


function _addMoverToDiv(div,mover){
   var m = div.mover;
	 if(m && m!=null){
	   m[m.length]=mover;
	 }
	 else{
	   div.mover=new Array();
		 div.mover[0]=mover;
	 }
}


function _getMouseX(evt){
  var currentX;
  if(document.all){
	  currentX = event.clientX + document.body.scrollLeft;
	}
	else{
	  currentX = evt.clientX + window.pageXOffset;
	}
	return currentX;
}

function _getMouseY(evt){
  var currentY;
  if(document.all){
	  currentY = event.clientY + document.body.scrollTop;
  }
	else{
	  currentY = evt.clientY + window.pageYOffset ;
	}
  return currentY;
}


function _getMover(element){
   var elm = element;
   while(elm && elm != document.documentDocument){
      if(elm.mover && (elm.mover!=null)) return elm;
      elm = elm.parentNode;
   }
   return null;
}

